
#ifndef _ARMADILLO210_GPIO_H_
#define _ARMADILLO210_GPIO_H_

struct wait_param{
	unsigned long list;    // wait GPIO list
	unsigned long timeout; // wait timeout
};

//ioctl command
#define PARAM_SET      0x00000001
//arg:(struct gpio_param *)

#define PARAM_GET      0x00000002
//arg:(struct gpio_param *)

#define INTERRUPT_WAIT 0x00000003
//arg:(struct wait_param *)


#define BIT(x)    (1<<(x))

#define GPIO_NUM 8

typedef enum __gpio_no_e{
  GPIO0    = BIT(0),
  GPIO1    = BIT(1),
  GPIO2    = BIT(2),
  GPIO3    = BIT(3),
  GPIO4    = BIT(4),
  GPIO5    = BIT(5),
  GPIO6    = BIT(6),
  GPIO7    = BIT(7),
}gpio_no_e;
  
typedef enum __int_type_e{
  //bit[0-1]:interrupt type
  TYPE_LOW_LEVEL    =0,
  TYPE_HIGH_LEVEL   =1,
  TYPE_FALLING_EDGE =2,
  TYPE_RISING_EDGE  =3,

  //bit[2]:debounce enable
  TYPE_DEBOUNCE     =4,
}int_type_e;

#define MODE_OUTPUT 0x00
#define MODE_INPUT  0x01
#define MODE_GET    0x02

struct output_param{
	unsigned long value;       // read/write value
	unsigned long reserved[3];
};

struct input_param{
	unsigned long value;       // read value
	unsigned long int_enable;  // {0:disable/1:enable}
	unsigned long int_type;    // {int_type_e}
	unsigned long resetved[1];
};

struct gpio_param{
	struct gpio_param *next;  // {NULL:end of list}
	unsigned long no;         // {gpio_no_e}
	unsigned long mode;       // {MODE_OUTPUT/MODE_INPUT}
	union{
		struct output_param o;
		struct input_param i;
	}data;
};


#endif
